 rem ooze.bas by Doug Dingus 1.5
 rem this code is licensed under the GPL
 rem 
 rem Written for Atari 2600 in Batari Basic
 rem for more info:  doug@opengeek.org
 rem
 rem Compile with Alpha 0.2 --later versions will require 
 rem bit comparison tweaks... (Noted within)
 rem v1.0 no history...
 rem v1.1 playable game, needs tweaks and code scrunch
 rem v1.2 code scrunch done by removing score, var cleanup
 rem      titlemap should go, but not yet.  Added 
 rem      score counter (scnt)
 rem v1.3 get powerups working
 rem      done:  ooze color, nogrow, fastfuel, gameslow, fast bullet, slow bullet
 rem      ooze now spreads just enough to trap player eventually
 rem      need to handle target & powerup & timedelay, etc to make levels
 rem      put levels into data statements for ooze difficulty
 rem      level time counter?
 rem      Indicate powerup by color!!!!
 rem 1.4  Working on level ups today, gonna change fuel to level timer.
 rem      Fuel no longer part of gameplay
 rem      lots 'o big changes, level display, etc...
 rem      almost there, need to setup levels and powerups and done!
 rem 1.5  level up code working, need to reset to restart however.
 rem      basic playtuning happening, levels ooze rates and colors
 rem      need to resolve how target works still --no target in this version
 rem      released for feedback



 rem smartbranching on


 gosub clearplayfield

 rem Init Game code
 rem define unused playfield bytes as variables not using scroll
 rem target hit counter --used for levels
 dim thc=playfield+44
 rem score counter
 dim scnt=playfield+45
 rem bullet miss penalty
 dim bdelay=playfield+46


 rem setup both sound channels
 AUDV0 = 0 : AUDV1 = 0 : AUDC1 = 12 : AUDC0 = 8
 AUDF0 = 0 : AUDF1 = 0

 rem init ship and bullet vars
 x = 60 : w = 0 : v = 0 : i = 20 : m = 50 : j = 0 : k = 0

 rem thc = target hit counter
 thc = 0

 rem r = game over delay to keep score on screen
 r = 60

 rem clear all status flags
 rem 0, 1 = number of player lives
 rem 2    = bullet launched flag
 rem 3    = 
 rem 4    = ship move delay toggle
 rem 5    = ship move speed fast / slow
 rem 6    = level up in progress
 rem 7    = color / BW mode
 s = 0

 rem start out with three lives
 rem s(1) = 1 : s(0) = 1
 s = 3

 rem clear secondary status flags
 rem 7    = ship hit flag
 rem 6    = target toggle, if hit then place it again
 rem 5    = special ooze erase flag for knocking back ooze
 rem 4    = 
 rem 3    = game over flag
 rem 2    = target direction toggle (x)
 rem 1    = target direction toggle (y)
 rem 0    = general speed toggle
 l = 0

 rem powerup & level flags
 rem 7 = nogrow
 rem 6 = fast level timer
 rem 5 = game slow
 rem 4 = fast bullet
 rem 3 = slow bullet
 rem 2 = ooze growth speed fast / slow
 rem 1 = don't clear playfield & reset ooze
 rem 0 = target in powerup mode
 p = 0




 rem q = counter / temp
 q = 0 : r = 0

 rem Clear ooze storage space a - h
 for temp1 = 0 to 7 : a[temp1] = 0 : next

 rem ooze growth factors
 z = 40 : y = 0

 rem level up & maybe bonus flags 
 u = 0

 rem set levelup parameters first level only.
 q = u
 i = leveldata[q] : q = q + 1
 p = leveldata[q] : q = q + 1
 z = leveldata[q]


gameloop
 rem handle color / BW switch
 q = u : q = q + 3
 if !s(7) then goto colorson
 COLUPF = leveldata[q] & $0f : COLUP0 = 9 : scorecolor = 15 : COLUP1 = 15
 q = q + 1
 COLUBK = leveldata[q] & $0f
 if l(6) then COLUP1 = leveldata[q] | $0f & $0f
 goto colordone
colorson
 COLUPF = leveldata[q] : COLUP0 = 120 : scorecolor = 70 : COLUP1 = 47
 q = q + 1
 COLUBK = leveldata[q]
 if l(6) then COLUP1 = leveldata[q] + $40 ^ %10101010
colordone

 if !l(5) then COLUPF = 54
 if !l(5) && s(7) then COLUPF = 2

 rem game over set background to grey
 if !l(3) then COLUBK = 5



 rem draw game border
 PF0 = 140


 rem bullet & display screen positions

 missile1x = w + 4 : missile1y = v : missile1height = 4

 rem set missile heights missile 0 = fuel display, 1 = bullet
 NUSIZ0 = $20 : NUSIZ1 = $0



 rem display ooze fall rate graphically
 rem keeping this in for playtuning, it can be swapped for fuel display
 rem missile0x = 165 : missile0y = 90 : missile0height = 56 - z

 rem display time to complete level graphically
 missile0x = 160 : missile0y = 90 : missile0height = i

 rem define player shapes
 rem put player ship where it needs to be
 player0x = x : player0y = 89
 player0:
 %01000010
 %11100111
 %11111111
 %01111110
 %00111100
 %00011000
 %00011000
 %00011000
end
 if s(6) then goto displaylevel
 if !l(6) then goto drawlives
 player1x = j : player1y = k
 if !p(0) then goto drawpowerup
 player1:
 %00111000
 %01000100
 %10100010
 %10100010
 %10110010
 %10100010
 %10111010
 %01000100
 %00111000
end
 goto drawlivesdone

drawpowerup
 player1:
 %00111000
 %01000100
 %10100010
 %10100010
 %10111010
 %10101010
 %10111010
 %01000100
 %00111000
end
 goto drawlivesdone
drawlives
 player1x = 26 : player1y = 85
 r = s
 r = r & 3
 on r goto 200 210 220 230
230 player1:
 %01111000
 %01111000
 %00000000
 %01111000
 %01111000
 %00000000
 %01111000
 %01111000
end
 goto drawlivesdone
220 player1:
 %01111000
 %01111000
 %00000000
 %01111000
 %01111000
end
 goto drawlivesdone
210 player1:
 %01111000
 %01111000
end
 goto drawlivesdone
200 player1:
 %00000000
 %00000000
end

drawlivesdone

 goto displayleveldone

displaylevel
 player1x = 85 : player1y = 50 : NUSIZ1 = 5
 r = u
 rem divide level counter by 8 to pick appropriate sprite
 asm
 lda r
 clc
 lsr
 lsr
 lsr
 sta r
end
 on r goto 330 340 350 360 370 380 390 400 410 420
330 player1:
 %00111000
 %00010000
 %00010000
 %00010000
 %00110000
end
 goto displayleveldone
340 player1:
 %00111000
 %00100000
 %00111000
 %00001000
 %00111000
end
 goto displayleveldone
350 player1:
 %00111000
 %00001000
 %00111000
 %00001000
 %00111000
end
 goto displayleveldone
360 player1:
 %00001000
 %00001000
 %00111000
 %00101000
 %00101000
end
 goto displayleveldone
370 player1:
 %00111000
 %00001000
 %00111000
 %00100000
 %00111000
end
 goto displayleveldone
380 player1:
 %00111000
 %00101000
 %00111000
 %00100000
 %00100000
end
 goto displayleveldone
390 player1:
 %00001000
 %00001000
 %00001000
 %00001000
 %00111000
end
 goto displayleveldone
400 player1:
 %00111000
 %00101000
 %00111000
 %00101000
 %00111000
end
 goto displayleveldone
410 player1:
 %00001000
 %00001000
 %00111000
 %00101000
 %00111000
end
 goto displayleveldone
420 player1:
 %01001110
 %01001010
 %01001010
 %01001010
 %01001110
end
displayleveldone

 rem draw the picture 60 times / second
 drawscreen





 rem GameCode --have ~2500 cycles per frame to work with
 rem dealing with gosub bug, using gotos for right now...

 rem if the game over flag is set, freeze game state for player to observe
 rem but let score count down
 if !l(3) then goto skipaction
 if s(6) then goto skipaction

 rem general toggle, used for game slow, etc...
 if l(0) then l(0) = 1 : goto dealwithspeed
 if !l(0) then l(0) = 0

dealwithspeed
 rem slow game down
 if p(5) then goto normalspeed
 if l(0) then goto halfspeed


normalspeed
 goto ooze
oozereturn

 goto knockback
knockback1

 goto movetarget
movetarget1

 goto moveship
moveship1

 goto moveshot
moveshot1


skipaction

 goto checkswitches
checkswitch1

 goto drawlevelup
drawlevelup1

 goto countscore
countscore1

 goto gameover
gameover1

halfspeed

 goto gameloop





 rem Subroutines Live below Here -------------------------



drawlevelup

 rem if level up flag is set, count down time until it is unset

 m = m - 1
 if m > 1 then goto drawlvldone
 i = i - 1 : m = 50
 if i > 1 then goto drawlvldone

 if s(6) then goto leveldelay
 gosub levelup
 goto drawlvldone

leveldelay
 if i > 1 then s(6) = 1
 s(6) = 0
playerwait
 rem set levelup parameters
 q = u
 i = leveldata[q] : q = q + 1
 p = leveldata[q] : q = q + 1
 z = leveldata[q]



drawlvldone
 goto drawlevelup1






 rem level up paramter data format is as follows;
 rem [time] [level options] [ooze diff] [ooze color] [background] [target action]
 rem [target frequency]
 rem target action bits determine what powerups happen during which levels
 rem plus coupla extra bytes to make ongoto level display work easily.
 rem level options detailed in init variable p
 rem target actions
 rem 7 = 
 rem 6 = 
 rem 5 = 
 rem 4 = 
 rem 3 = 
 rem 2 = 
 rem 1 = 
 rem 0 = 

 data leveldata
 60,%00000010,25,$b6,$0,%00000000,0,0
 80,%00000000,20,$14,$0,%00000000,0,0
 60,%00100000,18,$28,$0,%00000000,0,0
 35,%00001010,11,$36,$0,%00000000,0,0
 20,%00000000,23,$b4,$0,%00000000,0,0
 30,%00110000,30,$18,$0,%00000000,0,0
 90,%00001010,10,$26,$0,%00000000,0,0
 30,%00000100,30,$34,$0,%00000000,0,0
 40,%00000010,27,$ba,$0,%00000000,0,0
 40,%00000100,30,$1c,$0,%00000000,0,0
 99,%00000010,07,$26,$0,%00000000,0,0
 40,%00010100,13,$32,$0,%00000000,0,0
end



levelup

 rem clear playfield & zero ooze
 if p(1) then gosub clearplayfield

 rem quiet sound
 AUDV0 = 0 : AUDV1 = 0

 rem increment levelup counter
 u = u + 8

 if u = 80 then l(3) = 1 : goto gameover

 rem set levelup parameters
 q = u
 i = leveldata[q] : q = q + 1
 p = leveldata[q] : q = q + 1
 z = leveldata[q]

 rem set levelup in progress flags
 s(6) = 1 : i = 2

 return






movetarget

 if !l(6) then goto notarget

settarget

 if l(6) then goto checktarget
 rem turn fuel target mode on
 l(6) = 1

 rem set target position on upper portion of screen
 j = rand : k = rand
 j = j & 115 : k = k & 31
 j = j + 30 : k = k + 10


checktarget
 rem let see if player has hit the target
 q = CXM1P
 rem this is a bitmask compare, used because the bit compare 
 rem commands are buggy right now.  A mix is used in ooze
 rem and the contents of CXM1P with the bit to check (all others forced to 0)
 q = q & 64
 rem if the result is positive, the bit is set, otherwise cleared
 if q > 1 then p(0) = 1 : goto targethit




 rem move the target so player has a chance at hitting it even
 rem when pinned down by ooze
bouncetarget
 if rand < 40 then goto nobounce
 if !l(2) then j = j + 1
 if l(2) then j = j - 1
 if !l(1) then k = k + 1
 if l(1) then k = k - 1
 if j > 145 then l(2) = 0 : j = 145
 if j < 30 then l(2) = 1 : j = 30
 if k < 10 then l(1) = 1 : k = 10
 if k > 41 then l(1) = 0 : k = 41

nobounce
 if rand > 30 then goto nodirchange
 rem generate random direction vectors for target movement
 q = rand : q = q & 6
 l = l & 249 : l = l | q


nodirchange

 goto targetmissed

targethit

 rem turn target mode off & set hit flag
 l(6) = 0 : p(0) = 1

 rem add some big score
 scnt = scnt + 150

 rem put bullet back to where it came from
 rem w = x : v = 89 + 4 : AUDV0 = 0


targetmissed


notarget

 goto movetarget1



checkswitches
 if switchreset then  goto break
 rem set black 'n white mode
 if switchbw then s(7) = 1
 if !switchbw then s(7) = 0
 rem set ooze speed
 rem if switchrightb then s(6) = 0
 rem if !switchrightb then s(6) = 1
 rem set ship speed
 if switchleftb then s(5) = 1
 if !switchleftb then s(5) = 0
 rem debug option to increment levelups &  to test powerups
 rem if p(1) then goto joycheck
 rem goto joytoggle
 rem joycheck
 rem if joy0down then l(6) = 1 : p(0) = 0 : p(1) = 1 : goto joywait
 rem joytoggle
 rem if !joy0down then p(1) = 0
 rem joywait
 goto checkswitch1





countscore
 if scnt = 0 then goto countscore1
 scnt = scnt - 1
 if bdelay < 2 then score = score + 5
 goto countscore1

clearplayfield
 rem clear playfield
 rem and zero ooze storage variables
 asm
 ldx #47         ; set counter for number of bytes to clear
 lda #0          ; get a zero ready to put into each indexed byte
clearxx          ; top of loop
 sta playfield,x ; put the zero into the bytes, enumerated by X
 dex             ; step through the bytes one at a time until the first one is reached.
 bpl clearxx     ;continue until the index pointer reaches 255 (one below 0)
 sta a
 sta b
 sta c
 sta d
 sta e
 sta f
 sta g
 sta h
end
 return


knockback

 rem this routine knocks back the ooze for special ooze mode
 rem it jumps into the main ooze routine, setting the 
 rem ooze column value manually

 rem check the mode flag to decide if anything needs to be done
 rem almost all the routines are this way, everything executes
 rem every cycle, and only acts when it gets it's signal
 if l(5) then goto knockdone

 rem decrement the number of ooze columns to knock back
 n = n - 1
 if n > 1 then doknock



 rem if all the ooze is knocked, turn off the mode flag
 l(5) = 0


 goto knockdone

doknock

 rem knock all the ooze columns back, one after the other n times
 t = n & 15

 rem clear bottom line of playfield to clean up splatter
 asm
 lda #0
 sta playfield+43
 sta playfield+42
 sta playfield+41
 sta playfield+40
end

 rem make ooze back sound
 AUDF1 = 12 - n : AUDV1 = 5 + n

 goto oozeback


knockdone


 goto knockback1






ooze

 rem there is some duplicated code in here, but it's easier and
 rem we have plenty of room still

 rem keep ooze sound short
 AUDV1 = 0

 rem check for bullet to ooze collision
 rem if CXP1FB > 64 then goto hit

 rem check for bullet (missile 1) to ooze collision
 if CXM1FB > 64 then goto hit

 rem No hit?  Great!  Grow some more ooze to shoot at then.

 goto growooze

hit

 rem derive ooze column position from bullet x position 0 - 15
 rem divide by 8 
 t = w - 28
 asm
 lda t  ; load accumulator with whatever is contained in variable t
 clc    ; clear carry bit, otherwise it's contents are shifted in
 lsr    ; shift all the bits right, thus dividing by two
 lsr    ; and again for 4, and again for 8
 lsr
 sta t  ; put result back into variable t
end

oozeback

 rem kill bullet sound before we forget about it
 rem this brings w and v to work with for this routine.
 s(2) = 0

 rem use w to hold playfield pixel position
 w = t : w = w * 2 : v = 0


 rem upper or lower nibble?

 rem bit operations buggy, so mask off all but low bit and compare
 rem in the usual way
 r = t
 r = r & 1
 if r = 1 then goto hitupper

hitlower
 rem get ooze variable index r = t / 2
 r = t
 asm
 lda r ; another divide by two
 clc   ; this could be written r = r / 2 in basic
 lsr
 sta r
end

 rem pull out appropriate nibble, for erasing ooze pixels
 q = a[r]
 rem mask off the upper nibble with zeroes
 q = q & $0f

 rem store ooze position for scoring later
 v = q

 rem erase the ooze along with the adjacent one to properly fill
 rem everything in
 pfpixel w q flip : w = w + 1 : pfpixel w q flip


 rem decrement ooze column height and store value 
 q = q - 1
 rem check to see if it leaves playfield
 if q = 255 then q = 0

store1
 rem another bitmasking technique mask off the lower nibble of the 
 rem ooze column index (because we changed it above)
 a[r] = a[r] & $f0
 rem store the changed value in lower nibble without changing upper one
 a[r] = a[r] | q

 rem restore proper bullet position before leaving...
 rem w = x : v = 89 + 4 : AUDV0 = 0

 goto hitscore

hitupper

 rem get ooze variable index r = t / 2
 r = t / 2

 rem pull out appropriate nibble from packed ooze data 4 bits per ooze
 q = a[r]
 q = q & $f0

 rem divide by 16 to put upper nibble value into lower position for easy
 rem math and comparison
 asm
 lda q   ; load accumulator with contents of variable q
 clc
 lsr     ; divide in the usual way by 16 this time
 lsr
 lsr
 lsr
 sta q
end

 rem store ooze position for scoring later
 v = q


 rem erase the ooze along with the adjacent one to properly fill
 rem everything in
 pfpixel w q flip : w = w + 1 : pfpixel w q flip


 rem make ooze hit sound 
 rem maybe...

 rem decrement and store value 
 q = q - 1
 rem keep it in playfield bounds
 if q = 255 then q = 0


 rem multiply by 16 in order to put things back where they should 
 rem be

 asm
 lda q
 clc
 asl
 asl
 asl
 asl
 sta q
end

 rem the above divide by 16 and multiply by 16 operations are 
 rem important because they move the bits back and forth 
 rem within the variable byte 4 bits at a time.  This is how
 rem two ooze column positions are represented within one 
 rem variable easily.

 rem anding a value forces zero bits where there is a zero 
 rem and leaves the state of one bits unchanged
 a[r] = a[r] & $0f
 rem or-ing a value will change bits to a one if either 
 rem argument contains a 1 in that bit position.
 a[r] = a[r] | q

 rem the combination of the two allows bits of bytes to be 
 rem handled without disturbing the entire byte.

 rem restore proper bullet position before leaving...
 rem w = x : v = 89 + 4 : AUDV0 = 0


hitscore

 rem implemented score counter by frame instead of on goto
 rem score.  Fewer bytes --thanks supercat! (I think.)
 v = v * 2
 scnt = scnt + v

donescore

 rem restore proper bullet position before leaving...
 w = x : v = 89 - 4 : AUDV0 = 0

 if !l(5) then goto knockdone

growooze

 rem decide if we are to actually grow some ooze
 rem no growth in special mode, or powerup
 if p(7) then goto oozedone
 if !l(5) then goto oozedone

 rem only grow ooze every so often according to difficulty
 y = y + 1
 if !p(2) then y = y + 1
 if y < z then goto oozedone
 y = 0


 rem pick ooze column to work from 0-15
 t = rand : t = t & 15

 rem upper or lower nibble?

 rem bit operations buggy, so mask off all but low bit and compare
 rem in the usual way
 r = t
 r = r & 1
 if r = 1 then goto growupper

 rem get ooze variable index r = t / 2
growlower
 r = t
 asm
 lda r
 clc
 lsr
 sta r
end

 rem pull out appropriate nibble, do math on it, store it back to 
 rem ooze array variable for next time, keep value for plotting
 q = a[r]
 q = q & $0f
 q = q + 1
 if q = 11 then q = 10
 a[r] = a[r] & $f0
 a[r] = a[r] | q

 rem multiply ooze var index by 4 to obtain playfield pixel location
 asm
 lda r
 clc
 asl
 asl
 sta r
end

 rem put ooze on screen, along with the adjacent one to properly fill
 rem everything in
 pfpixel r q on : r = r + 1 : pfpixel r q on
 if q < 10 then goto nosplat0
 r = r - 3
 if r < 31 then pfpixel r q on : r = r + 1 : pfpixel r q on : r = r + 3 : goto otherhalf
 r = r + 4
otherhalf
 if r < 31 then pfpixel r q on : r = r + 1 : pfpixel r q on
nosplat0
 rem trigger the ooze growth sound
 rem pitch determined by vertical depth, volume by same
 AUDF1 = 12 - q : AUDV1 = 5 + q

 goto oozedone

growupper

 rem get ooze var array index r = t / 2
 r = t
 asm
 lda r
 clc
 lsr
 sta r
end

 rem grab value and mask off lower nibble
 q = a[r]
 q = q & $f0

 rem when working with the upper nibble, divide by 16 to do math and plot
 rem multiply by 16 to put back into ooze array variable
 asm
 lda q
 clc
 lsr
 lsr
 lsr
 lsr
 sta q
end

 rem add to ooze column length
 q = q + 1
 if q = 11 then q = 10


 rem hold this value for plotting
 t = q

 rem shift it up 4 bits to put it back in to array variable
 asm 
 lda q
 clc
 asl
 asl
 asl
 asl
 sta q
end

 rem zero upper nibble of ooze variable & or in the new value
 a[r] = a[r] & $0f
 a[r] = a[r] | q

 rem multiply ooze index by two to get playfield position
 asm
 lda r
 clc
 asl
 asl
 sta r
end

 rem we know upper nibbles are odd columns, so do the math accordingly.
 r = r + 2 : pfpixel r t on : r = r + 1 : pfpixel r t on

 if t < 10 then goto nosplat1
 r = r - 3
 if r < 31 then pfpixel r t on : r = r + 1 : pfpixel r t on : r = r + 3 : goto otherhalf1
 r = r + 4
otherhalf1
 if r < 31 then pfpixel r t on : r = r + 1 : pfpixel r t on
nosplat1

 rem the ooze sound again
 AUDF1 = 12 - t : AUDV1 = 6 + t

oozedone


 goto oozereturn











moveship
 if !s(4) then s(4) = 0 : goto shipslow
 if s(5) then s(4) = 1
 if joy0left then x = x - 2
 if joy0right then x = x + 2
 if x < 31 then x = 31
 if x > 151 then x = 151
 rem the two lines below are for debugging the ooze knockback
 rem if joy0up then l(5) = 1 : n = 20
 rem if joy0down then l(5) = 0
shipslow

 rem check to see if ooze has touched the ship
 rem there are basic commands for this, I just like using the 
 rem registers directly.  Safer and less potential for language
 rem syntax change to break things.
 if CXP0FB > 64 then goto shiphit
 goto shipsafe

shiphit
 if !l(5) then goto shipsafe
 rem preserve game flags
 q = s
 rem mask off all but ship count
 q = q & 3
 rem if no more ships, game over
 q = q - 1
 if q = 0 then l(3) = 1 : goto gameover
 rem put new ship count back where it should be
 s = s & 252
 s = s | q
 rem knockback ooze
 l(5) = 1 : n = 32
 rem new ship, new fuel disable fuel target
 i = 25 : l(6) = 0

shipsafe

extraship
 q = o & 15
 if q <> 15 then goto moveship1

 rem extra ship awarded
 q = s
 rem flash b&w to signify extra ship
 s(7) = 1
 rem credit an extra target hit also
 thc = thc + 1
 rem get the ship count
 q = q & 3
 rem if room for extra ship add it, otherwise exit
 if q = 3 then goto moveship1
 q = q + 1
 rem put new shipcount back where it belongs
 s = s & 252
 s = s | q

 goto moveship1







moveshot
 if !l(5) then goto shotdone
 if !s(2) then goto fire
 if bdelay <> 0 then bdelay = bdelay - 1
 if bdelay > 1 then goto bwait
 if joy0fire then s(2) = 1 : goto fire
bwait
 w = x : v = 89 - 4
 goto shotdone
 rem bit operators are working backward, change this code when it gets 
 rem fixed.  Symptom will be always shooting  bits 6 & 7 work correctly the rest dont.
fire
 rem handle bullet speed flags 
 v = v - 4
 if !p(4) then v = v - 2
 if !p(3) then v = v + 3
 AUDF0 = v : AUDV0 = 8
 if v < 5 then s(2) = 0 : v = 89 + 4 : w = x : bdelay = 99 : AUDV0 = 0
shotdone
 goto moveshot1










gameover

 if l(3) then goto notgameover
 AUDV0 = 0 : AUDV1 = 0
 r = r - 1
 if r > 1 then goto notgameover

 rem quiet the sound
 AUDV0 = 0 : AUDV1 = 0
 r = 20
 rem this line checks the joystick button briefly every half 
 rem second.  The result being the player needs to hold down
 rem the button to restart the game.
 if joy0fire then l(3) = 0 : goto break

notgameover
 goto gameover1


 rem -------------- Title Screen -------------------------

 rem found in ooze.title.bas for lack of room right now
 rem ~512 bytes...

 rem this little bit of code resets the machine.
break

 s = 0
 asm
 brk
end

